<?php

include(dirname(__FILE__).'/../../config/config.inc.php');
include(dirname(__FILE__).'/gopay.php');
include(dirname(__FILE__).'/gopaySpecial.php');

$errors = '';
$result = false;
$gopay = new Gopay();
$gopaySpecial = new GopaySpecial();
					
		// parametry zadane v konfiguraci
		$goId = trim(Configuration::get('GOID'));
		$gopayKey = trim(Configuration::get('GOPAY_KEY'));
		$failedUrl = trim(Configuration::get('GOPAY_FAILED_URL'));
		$successUrl = trim(Configuration::get('GOPAY_SUCCESS_URL'));
		$gopayBaseUrl = trim(Configuration::get('GOPAY_BASE_URL'));
		$historyUrl = trim(Configuration::get('GOPAY_HISTORY_URL'));
	
		// cart z parametru
		$cartId = $_POST['cartId'];
		$cart = new Cart($cartId);
		
		// castka predavana validateOrder
		$cartSummary = $cart->getSummaryDetails();
		$nonConvertedAmount = $cartSummary['total_price'];
			
		if($cart->OrderExists()) {
			$errors .= $gopay->getL('alreadyPaid');
			Tools::redirectLink("$historyUrl?errors=$errors");			
		}
				
		// ziskani id ceske meny
		$czk_id = Currency::getIdByIsoCode('CZK');
		
		// overeni existence ceske meny s ISO CZK
		if ($czk_id == ''){
			$errors .= $gopay->getL('czk');
			Tools::redirectLink("$historyUrl?errors=$errors");
		}
		else {
			// cart v CZK
			$cart->id_currency = intval($czk_id);
			$cart->save();
												
			// vytvoreni a nacteni nove objednavky			
			$gopay->validateOrder($cart->id,_PS_OS_GOPAY_,$nonConvertedAmount,$gopay->displayName);
			$orderId = Order::getOrderByCartId($cart->id);
			$order = new Order($orderId);
			
			$productNameConcat = $gopaySpecial->concatProductsNames($order);
			$amount = number_format($order->total_paid,2,'','');
			
			if(isset($order)){
				// vytvoreni platby
				$paymentSessionId=GopaySoap::createPayment(
										$goId,
										$productNameConcat, 
										$amount,
										$orderId,
										$successUrl,
										$failedUrl,
										$gopayKey								
				);
				
				if ($paymentSessionId > 0) {
				$encryptedSignature=GopayHelper::encrypt(
					GopayHelper::hash(
						GopayHelper::concatPaymentSession(
								$goId,
								$paymentSessionId,
								$gopayKey
							)
					),
					$gopayKey);
				}
				else {
					$errors .= $gopay->getL('paymentCreationFailed');
				}
			}
			else {
				$errors .= $gopay->getL('undefinedOrderFaultyState');
			}																
			
			if(empty($errors)) {
				Tools::redirectLink("$gopayBaseUrl?sessionInfo.paymentSessionId=$paymentSessionId&sessionInfo.eshopGoId=$goId&sessionInfo.encryptedSignature=$encryptedSignature");			
			}
			else {
				Tools::redirectLink("$historyUrl?errors=$errors");
			}
		}
?>